﻿using System;
using System.Collections.Generic;
using System.Text;

namespace SSTFEditor
{
	public delegate void DGRedoを実行する<T>( T 変更対象, T 変更前の値, T 変更後の値, object 任意1, object 任意2 );
	public delegate void DGUndoを実行する<T>( T 変更対象, T 変更前の値, T 変更後の値, object 任意1, object 任意2 );

	class CUndoRedoセル<T> : CUndoRedoセルBase
	{
		public T 変更対象;
		public T 変更前の値;
		public T 変更後の値;
		public object 任意1;	// 任意に使えるパラメータ領域
		public object 任意2;	//

		public CUndoRedoセル( object 所有者ID, DGUndoを実行する<T> undoメソッド, DGRedoを実行する<T> redoメソッド, T 変更対象, T 変更前の値, T 変更後の値, object 任意1, object 任意2 )
		{
			base.所有者ID = 所有者ID;
			this.undoデリゲート = undoメソッド;
			this.redoデリゲート = redoメソッド;
			this.変更対象 = 変更対象;
			this.変更前の値 = 変更前の値;
			this.変更後の値 = 変更後の値;
			this.任意1 = 任意1;
			this.任意2 = 任意2;
		}
		public override void tRedoを実行する()
		{
			base.所有者ID = null;
			this.redoデリゲート( this.変更対象, this.変更前の値, this.変更後の値, this.任意1, this.任意2 );
		}
		public override void tUndoを実行する()
		{
			base.所有者ID = null;
			this.undoデリゲート( this.変更対象, this.変更前の値, this.変更後の値, this.任意1, this.任意2 );
		}

		#region [ protected ]
		//-----------------
		protected DGRedoを実行する<T> redoデリゲート;
		protected DGUndoを実行する<T> undoデリゲート;
		//-----------------
		#endregion
	}
}
