﻿using System;
using System.Collections.Generic;
using System.Text;

namespace SSTFEditor
{
	class CUndoRedo
	{
		// プロパティ

		public static bool bUndoRedoした直後 = false;
		
		public int nRedo可能な回数
		{
			get
			{
				return ( this.n現在の総ノード数 - this.nUndo可能な回数 );
			}
		}
		public int nUndo可能な回数
		{
			get
			{
				return this.root.nUndo可能な回数;
			}
		}
		public int n現在の総ノード数
		{
			get
			{
				return this.root.n現在の総セル数;
			}
		}


		// メソッド

		public CUndoRedo()
		{
			this.urd現在のセル = this.root;
		}
		
		public CUndoRedoセルBase tRedoするセルを取得して返す()
		{
			this.urd現在のセル = this.root;

			if( this.root.nRedo可能な回数 <= 0 )
				return null;

			this.root.n次にセルが追加される位置0to++;
			return this.root.listセル[ this.root.n次にセルが追加される位置0to - 1 ];
		}
		public CUndoRedoセルBase tUndoするセルを取得して返す()
		{
			this.urd現在のセル = this.root;

			if( this.root.nUndo可能な回数 <= 0 )
				return null;

			this.root.n次にセルが追加される位置0to--;
			return this.root.listセル[ this.root.n次にセルが追加される位置0to ];
		}
		public CUndoRedoセルBase tUndoするセルを取得して返す・見るだけ()
		{
			this.urd現在のセル = this.root;

			if( this.root.nUndo可能な回数 <= 0 )
				return null;

			return this.root.listセル[ this.root.n次にセルが追加される位置0to - 1 ];
		}
		
		public void tセルを追加する( CUndoRedoセルBase ur単独セル )
		{
			#region [ 追加するセルの後方にあるセルをすべて削除。]
			//-----------------
			int index = this.urd現在のセル.n次にセルが追加される位置0to;
			int count = this.urd現在のセル.n現在の総セル数 - this.urd現在のセル.n次にセルが追加される位置0to;
			if( count > 0 )
				this.urd現在のセル.listセル.RemoveRange( index, count );
			//-----------------
			#endregion

			this.urd現在のセル.listセル.Add( ur単独セル );
			this.urd現在のセル.n次にセルが追加される位置0to++;
		}
		
		public void tトランザクション記録を開始する()
		{
			#region [ 追加するセルの後方にあるセルをすべて削除。]
			//-----------------
			int index = this.urd現在のセル.n次にセルが追加される位置0to;
			int count = this.urd現在のセル.n現在の総セル数 - this.urd現在のセル.n次にセルが追加される位置0to;
			if( count > 0 )
				this.urd現在のセル.listセル.RemoveRange( index, count );
			//-----------------
			#endregion

			// リストセルを追加して開く。

			var dir = new CUndoRedoリスト( this.urd現在のセル );	// 現在のセルが親セル。
			this.urd現在のセル.listセル.Add( dir );
			this.urd現在のセル.n次にセルが追加される位置0to++;
			this.urd現在のセル = dir;
		}
		public void tトランザクション記録を終了する()
		{
			// リストセルを閉じる。

			if( this.urd現在のセル.urd親セル != null )
			{
				CUndoRedoリスト dir = this.urd現在のセル;
				this.urd現在のセル = this.urd現在のセル.urd親セル;
				
				if( dir.listセル.Count == 0 )
				{
					this.urd現在のセル.listセル.Remove( dir );
					this.urd現在のセル.n次にセルが追加される位置0to--;
				}
			}
		}
		
		public void tUndoRedoリストをすべて空にする()
		{
			this.root = new CUndoRedoリスト( null );
			this.urd現在のセル = this.root;
		}


		#region [ protected ]
		//-----------------
		protected CUndoRedoリスト root = new CUndoRedoリスト( null );
		protected CUndoRedoリスト urd現在のセル;
		//-----------------
		#endregion
	}
}
