﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace SSTFEditor
{
	partial class C検索条件入力ダイアログ : Form
	{
		public bool b小節範囲指定CheckBoxがチェックされている
		{
			get
			{
				return this.checkBox小節範囲指定.Checked;
			}
		}
		public int n小節範囲開始番号
		{
			get
			{
				int num2;
				if( this.textBox小節範囲開始.Text.Length > 0 )
				{
					int num;
					if( !int.TryParse( this.textBox小節範囲開始.Text, out num ) )
					{
						num = -1;
					}
					return num;
				}
				if( this.textBox小節範囲終了.Text.Length <= 0 )
				{
					return -1;
				}
				if( !int.TryParse( this.textBox小節範囲終了.Text, out num2 ) )
				{
					num2 = -1;
				}
				return num2;
			}
		}
		public int n小節範囲終了番号
		{
			get
			{
				int num2;
				if( this.textBox小節範囲終了.Text.Length > 0 )
				{
					int num;
					if( !int.TryParse( this.textBox小節範囲終了.Text, out num ) )
					{
						num = -1;
					}
					return num;
				}
				if( this.textBox小節範囲開始.Text.Length <= 0 )
				{
					return -1;
				}
				if( !int.TryParse( this.textBox小節範囲開始.Text, out num2 ) )
				{
					num2 = -1;
				}
				return num2;
			}
		}

		public C検索条件入力ダイアログ()
		{
			InitializeComponent();

			#region [ レーンリストとレーンリストチェックに前回値を指定する。未初期化なら初期化する。]
			//-----------------
			if( b前回値・レーンリストチェック == null )
			{
				b前回値・レーンリストチェック = new bool[ this.dic行と編集レーン対応表.Count ];
				for( int i = 0; i < this.dic行と編集レーン対応表.Count; i++ )
					b前回値・レーンリストチェック[ i ] = false;	// 前回値をすべて false にする。
			}
			foreach( var kvp in this.dic行と編集レーン対応表 )
				this.checkedListBoxレーン選択リスト.Items.Add( this.str編集レーン名[ kvp.Key ], b前回値・レーンリストチェック[ kvp.Key ] );
			//-----------------
			#endregion
			#region [ チップリストとチップリストチェックに前回値を指定する。未初期化なら初期化する。]
			//-----------------
			if( b前回値・チップリストチェック == null )
			{
				b前回値・チップリストチェック = new bool[ this.dic行とチップ種別対応表.Count ];
				for( int i = 0; i < this.dic行とチップ種別対応表.Count; i++ )
					b前回値・チップリストチェック[ i ] = false;	// 前回値をすべて false にする。
			}
			foreach( var kvp in this.dic行とチップ種別対応表 )
				this.checkedListBoxチップ選択リスト.Items.Add( this.strチップ種別名[ kvp.Key ], b前回値・チップリストチェック[ kvp.Key ] );
			//-----------------
			#endregion

			this.checkBox小節範囲指定.CheckState = ( b前回値・小節範囲指定 ) ? CheckState.Checked : CheckState.Unchecked;
			this.tチェックに連動して有効・無効が決まるパーツについてEnabledを設定する();
		}

		public bool b指定した編集レーンが選択されている( E編集レーン e編集レーン )
		{
			foreach( var kvp in this.dic行と編集レーン対応表 )
			{
				if( kvp.Value == e編集レーン )
					return ( this.checkedListBoxレーン選択リスト.GetItemCheckState( kvp.Key ) == CheckState.Checked );
			}
			return false;
		}
		public bool b指定したチップ種別が選択されている( StrokeStyleT.Eチップ eチップ )
		{
			foreach( var kvp in this.dic行とチップ種別対応表 )
			{
				if( kvp.Value == eチップ )
					return ( this.checkedListBoxチップ選択リスト.GetItemCheckState( kvp.Key ) == CheckState.Checked );
			}
			return false;
		}

		#region [ protected ]
		//-----------------

		protected static bool b前回値・小節範囲指定 = false;
		protected static bool[] b前回値・レーンリストチェック = null;
		protected static bool[] b前回値・チップリストチェック = null;


		// 定数プロパティ

		protected readonly Dictionary<int, E編集レーン> dic行と編集レーン対応表
			#region [ **** ]
			//-----------------
			= new Dictionary<int, E編集レーン>() {
				{ 0, E編集レーン.BPM },
				{ 1, E編集レーン.左シンバル },
				{ 2, E編集レーン.ハイハット },
				{ 3, E編集レーン.スネア },
				{ 4, E編集レーン.ハイタム },
				{ 5, E編集レーン.バス },
				{ 6, E編集レーン.ロータム },
				{ 7, E編集レーン.フロアタム },
				{ 8, E編集レーン.右シンバル },
				{ 9, E編集レーン.背景動画 },
			};
			//-----------------
			#endregion
		
		protected readonly string[] str編集レーン名
			#region [ **** ]
			//-----------------
			= new string[] {
				"BPM",
				"Left Cymbal",
				"HiHat",
				"Snare",
				"High Tom",
				"Bass Drum",
				"Low Tom",
				"Floor Tom",
				"Right Cymbal",
				"BGA",
			};
		//-----------------
			#endregion

		protected readonly Dictionary<int, StrokeStyleT.Eチップ> dic行とチップ種別対応表
			#region [ **** ]
			//-----------------
			= new Dictionary<int, StrokeStyleT.Eチップ>() {
				{ 0, StrokeStyleT.Eチップ.BPM },
				{ 1, StrokeStyleT.Eチップ.LeftCrash },
				{ 2, StrokeStyleT.Eチップ.HiHat_Close },
				{ 3, StrokeStyleT.Eチップ.HiHat_HalfOpen },
				{ 4, StrokeStyleT.Eチップ.HiHat_Open },
				{ 5, StrokeStyleT.Eチップ.HiHat_Foot },
				{ 6, StrokeStyleT.Eチップ.Snare },
				{ 7, StrokeStyleT.Eチップ.Snare_Ghost },
				{ 8, StrokeStyleT.Eチップ.Snare_ClosedRim },
				{ 9, StrokeStyleT.Eチップ.Snare_OpenRim },
				{ 10, StrokeStyleT.Eチップ.Tom1 },
				{ 11, StrokeStyleT.Eチップ.Tom1_Rim },
				{ 12, StrokeStyleT.Eチップ.Bass },
				{ 13, StrokeStyleT.Eチップ.Tom2 },
				{ 14, StrokeStyleT.Eチップ.Tom2_Rim },
				{ 15, StrokeStyleT.Eチップ.Tom3 },
				{ 16, StrokeStyleT.Eチップ.Tom3_Rim },
				{ 17, StrokeStyleT.Eチップ.RightCrash },
				{ 18, StrokeStyleT.Eチップ.Ride },
				{ 19, StrokeStyleT.Eチップ.Ride_Cup },
				{ 20, StrokeStyleT.Eチップ.China },
				{ 21, StrokeStyleT.Eチップ.Splash },
				{ 22, StrokeStyleT.Eチップ.背景動画 },
			};
			//-----------------
			#endregion

		protected readonly string[] strチップ種別名
			#region [ **** ]
			//-----------------
			= new string[] {
				"BPM",
				"Left Crash",
				"HiHat Close",
				"HiHat HalfOpen",
				"HiHat Open",
				"Foot Pedal",
				"Snare",
				"Snare Ghost",
				"Snare Closed RimShot",
				"Snare Open RimShot",
				"High Tom",
				"High Tom RimShoft",
				"Bass Drum",
				"Low Tom",
				"Low Tom RimShot",
				"Floor Tom",
				"Floor Tom RimShoft",
				"Right Crash",
				"Ride",
				"Cup",
				"China Cymbal",
				"Splash Cymbal",
				"BGA",
			};
			//-----------------
			#endregion


		// メソッド

		protected void tチェックに連動して有効・無効が決まるパーツについてEnabledを設定する()
		{
			bool flag = this.checkBox小節範囲指定.Checked;
			this.textBox小節範囲開始.Enabled = flag;
			this.textBox小節範囲終了.Enabled = flag;
		}


		// イベント

		protected void C検索条件入力ダイアログ_FormClosing( object sender, FormClosingEventArgs e )
		{
			if( this.DialogResult == DialogResult.OK )
			{
				// 入力値の妥当性を確認する。

				string text;
				int num;

				#region [ 小節範囲開始 ]
				//-----------------
				text = this.textBox小節範囲開始.Text;
				if( text.Length > 0 && ( !int.TryParse( text, out num ) || num < 0 ) )
				{
					MessageBox.Show( Properties.Resources.MSG_小節番号に誤りがあります + Environment.NewLine +
						"'" + text + "'", Properties.Resources.MSG_エラーダイアログのタイトル,
						MessageBoxButtons.OK, MessageBoxIcon.Hand, MessageBoxDefaultButton.Button1 );
					this.textBox小節範囲開始.Focus();
					this.textBox小節範囲開始.SelectAll();
					e.Cancel = true;
					return;
				}
				//-----------------
				#endregion
				#region [ 小節範囲終了 ]
				//-----------------
				text = this.textBox小節範囲終了.Text;
				if( text.Length > 0 && ( !int.TryParse( text, out num ) || num < 0 ) )
				{
					MessageBox.Show( Properties.Resources.MSG_小節番号に誤りがあります + Environment.NewLine +
						"'" + text + "'", Properties.Resources.MSG_エラーダイアログのタイトル,
						MessageBoxButtons.OK, MessageBoxIcon.Hand, MessageBoxDefaultButton.Button1 );
					this.textBox小節範囲終了.Focus();
					this.textBox小節範囲終了.SelectAll();
					e.Cancel = true;
					return;
				}
				//-----------------
				#endregion


				// 入力値を前回値として保存する。

				#region [ b前回値・小節範囲指定 ]
				//-----------------
				b前回値・小節範囲指定 = this.checkBox小節範囲指定.Checked;
				//-----------------
				#endregion
				#region [ b前回値・レーンリストチェック[] ]
				//-----------------
				for( int i = 0; i < this.checkedListBoxレーン選択リスト.Items.Count; i++ )
					b前回値・レーンリストチェック[ i ] = this.checkedListBoxレーン選択リスト.GetItemCheckState( i ) == CheckState.Checked;
				//-----------------
				#endregion
				#region [ b前回値・チップリストチェック[] ]
				//-----------------
				for( int i = 0; i < this.checkedListBoxチップ選択リスト.Items.Count; i++ )
					b前回値・チップリストチェック[ i ] = this.checkedListBoxチップ選択リスト.GetItemCheckState( i ) == CheckState.Checked;
				//-----------------
				#endregion
			}
		}
		protected void C検索条件入力ダイアログ_KeyDown( object sender, KeyEventArgs e )
		{
			if( e.KeyCode == Keys.Return )
				this.buttonOK.PerformClick();	// ENTER は OK
			
			else if( e.KeyCode == Keys.Escape )
				this.buttonキャンセル.PerformClick();	// ESC は Cancel
		}
		protected void textBox小節範囲開始_KeyDown( object sender, KeyEventArgs e )
		{
			if( e.KeyCode == Keys.Return )
				this.buttonOK.PerformClick();	// ENTER は OK

			else if( e.KeyCode == Keys.Escape )
				this.buttonキャンセル.PerformClick();	// ESC は Cancel
		}
		protected void textBox小節範囲終了_KeyDown( object sender, KeyEventArgs e )
		{
			if( e.KeyCode == Keys.Return )
				this.buttonOK.PerformClick();	// ENTER は OK

			else if( e.KeyCode == Keys.Escape )
				this.buttonキャンセル.PerformClick();	// ESC は Cancel
		}
		protected void checkBox小節範囲指定_CheckStateChanged( object sender, EventArgs e )
		{
			this.tチェックに連動して有効・無効が決まるパーツについてEnabledを設定する();
		}
		protected void checkBox小節範囲指定_KeyDown( object sender, KeyEventArgs e )
		{
			if( e.KeyCode == Keys.Return )
				this.buttonOK.PerformClick();	// ENTER は OK

			else if( e.KeyCode == Keys.Escape )
				this.buttonキャンセル.PerformClick();	// ESC は Cancel
		}
		protected void checkedListBoxレーン選択リスト_KeyDown( object sender, KeyEventArgs e )
		{
			if( e.KeyCode == Keys.Return )
				this.buttonOK.PerformClick();	// ENTER は OK

			else if( e.KeyCode == Keys.Escape )
				this.buttonキャンセル.PerformClick();	// ESC は Cancel
		}
		protected void buttonAllレーン_Click( object sender, EventArgs e )
		{
			for( int i = 0; i < this.checkedListBoxレーン選択リスト.Items.Count; i++ )
				this.checkedListBoxレーン選択リスト.SetItemChecked( i, true );
		}
		protected void buttonAllレーン_KeyDown( object sender, KeyEventArgs e )
		{
			if( e.KeyCode == Keys.Escape )
				this.buttonキャンセル.PerformClick();	// ESC は Cancel
		}
		protected void buttonClearレーン_Click( object sender, EventArgs e )
		{
			for( int i = 0; i < this.checkedListBoxレーン選択リスト.Items.Count; i++ )
				this.checkedListBoxレーン選択リスト.SetItemCheckState( i, CheckState.Unchecked );
		}
		protected void buttonClearレーン_KeyDown( object sender, KeyEventArgs e )
		{
			if( e.KeyCode == Keys.Escape )
				this.buttonキャンセル.PerformClick();	// ESC は Cancel
		}
		protected void buttonAllチップ_Click( object sender, EventArgs e )
		{
			for( int i = 0; i < this.checkedListBoxチップ選択リスト.Items.Count; i++ )
				this.checkedListBoxチップ選択リスト.SetItemChecked( i, true );

		}
		protected void buttonAllチップ_KeyDown( object sender, KeyEventArgs e )
		{
			if( e.KeyCode == Keys.Escape )
				this.buttonキャンセル.PerformClick();	// ESC は Cancel
		}
		protected void buttonClearチップ_Click( object sender, EventArgs e )
		{
			for( int i = 0; i < this.checkedListBoxチップ選択リスト.Items.Count; i++ )
				this.checkedListBoxチップ選択リスト.SetItemCheckState( i, CheckState.Unchecked );
		}
		protected void buttonClearチップ_KeyDown( object sender, KeyEventArgs e )
		{
			if( e.KeyCode == Keys.Escape )
				this.buttonキャンセル.PerformClick();	// ESC は Cancel
		}
		//-----------------
		#endregion
	}
}
